//-----------------------------------------
// Array Clone -- item clone generic LScript
// Arnie Cachelin   2000 Copyright NewTek, Inc.
//
//  Clone an item, offsetting each clone in X, Y, and/or Z, into a regular array.
//  The objects will have a random placement of + or - the jitter amount.
//
@version 2.1
@warnings
@script generic


generic
{
    if(!reqbegin("Array Clone"))
        return;

    reqsize(187,330);

    c1 = ctlinteger("X: Count",1);
    ctlposition(c1,19,17);
    c4 = ctldistance("Spacing",4.0);
    ctlposition(c4,19,44);
    c7 = ctldistance("Jitter",7.0);
    ctlposition(c7,19,71);

    s1 = ctlsep(9,165);
    ctlposition(s1,9,98);

    c2 = ctlinteger("Y: Count",2);
    ctlposition(c2,19,111);
    c5 = ctldistance("Spacing",5.0);
    ctlposition(c5,19,138);
    c8 = ctldistance("Jitter",8.0);
    ctlposition(c8,19,165);

    s2 = ctlsep(5,173);
    ctlposition(s2,5,192);

    c3 = ctlinteger("Z: Count",3);
    ctlposition(c3,19,205);
    c6 = ctldistance("Spacing",6.0);
    ctlposition(c6,19,232);
    c9 = ctldistance("Jitter",9.0);
    ctlposition(c9,20,260);
 
    setvalue(c1, 2);
    setvalue(c2, 1);
    setvalue(c3, 2);
    setvalue(c4, 1.0);
    setvalue(c5, 1.0);
    setvalue(c6, 1.0);
    setvalue(c7, 0.0);
    setvalue(c8, 0.0);
    setvalue(c9, 0.0);

    if(reqpost())
    {
        xn = getvalue(c1);
        yn = getvalue(c2);
        zn = getvalue(c3);

        xd = getvalue(c4);
        yd = getvalue(c5);
        zd = getvalue(c6);

        xj = getvalue(c7);
        yj = getvalue(c8);
        zj = getvalue(c9);

        lnum = xn*yn*zn - 1;
        x = 0;
        y = 0;
        z = 0;

        first = Scene().firstSelect();
        start = first.getWorldPosition(0.0);

        Clone(lnum);
        NextItem(); // leave original in place
        for(lay = 0; lay<zn; lay++)
        {
            for(row = 0; row<yn ; row++)
            {
                for(col = 0; col<xn ; col++)
                {
					tx = x + start.x + random(-1,1)*xj;
					ty = y + start.y + random(-1,1)*yj;
					tz = z + start.z + random(-1,1)*zj;
                    Position(tx,ty,tz);
                    x = x + xd;
                    NextItem();
                }
                y = y + yd;
                x = 0;
            }
            z = z + zd;
            x = 0;
            y = 0;
        }
    }
    reqend();
}

